//---------------------------------------------------------------------------
// @: Lg
// e-mail:lcsboy@pchome.com.tw
//pn, ХoPN
//

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::GetLastErrorStr()
{
        LPVOID lpMsgBuf;
        FormatMessage(
          FORMAT_MESSAGE_ALLOCATE_BUFFER |
          FORMAT_MESSAGE_FROM_SYSTEM |
          FORMAT_MESSAGE_IGNORE_INSERTS,
          NULL,
          GetLastError(),
          MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
          (LPTSTR) &lpMsgBuf,
          0,
          NULL );
        MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error!", MB_OK | MB_ICONINFORMATION );
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        EnumerateDevices();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EnumerateDevices()
{
        HDEVINFO DeviceHandle;
        SP_DEVINFO_DATA DeviceInfo;
        DWORD Index=0;
        DeviceHandle=SetupDiGetClassDevs(NULL, NULL, NULL, DIGCF_ALLCLASSES | DIGCF_PRESENT);

        Label1->Caption="";
        ListView1->Items->Clear();
        ListView1->Update();

        do {
          if (DeviceHandle==INVALID_HANDLE_VALUE)
          {
            GetLastErrorStr();
            break;
          }

          DeviceInfo.cbSize = sizeof(SP_DEVINFO_DATA);
          while (SetupDiEnumDeviceInfo(DeviceHandle, Index, &DeviceInfo)){
            ShowDeviceInfo(DeviceHandle, &DeviceInfo);
            Index++;
          }
        } while (0);

        if(DeviceHandle!=INVALID_HANDLE_VALUE)
          SetupDiDestroyDeviceInfoList(DeviceHandle);

        Label1->Caption="Total  "+String(ListView1->Items->Count)+"  devices";

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowDeviceInfo(HDEVINFO DeviceHandle, PSP_DEVINFO_DATA DeviceInfo)
{
#define DNF_INF_IS_SIGNED       0x00002000  // If file is digitally signed
#define DI_FLAGSEX_INSTALLEDDRIVER          0x04000000L  // only add the installed driver to the class or compat

        char Buffer[MAX_PATH];
        SP_DEVINSTALL_PARAMS DeviceInstallParams;
        SP_DRVINSTALL_PARAMS DriverInstallParams;
        SP_DRVINFO_DATA DriverInfo;
        SP_DRVINFO_DETAIL_DATA DriverInfoDetail;
        SP_DEVINFO_LIST_DETAIL_DATA DeviceInfoListDetail;
        SYSTEMTIME SystemTime;
        ULARGE_INTEGER Version;
        DWORD Index=0;

        ZeroMemory(&DeviceInstallParams, sizeof(SP_DEVINSTALL_PARAMS));
        DeviceInstallParams.cbSize = sizeof(SP_DEVINSTALL_PARAMS);
        ZeroMemory(&DriverInfo, sizeof(SP_DRVINFO_DATA));
        DriverInfo.cbSize = sizeof(SP_DRVINFO_DATA);
        if (!SetupDiGetDeviceInstallParams(DeviceHandle, DeviceInfo, &DeviceInstallParams))
        {
          GetLastErrorStr();
          return;
        }
        DeviceInstallParams.FlagsEx |= (DI_FLAGSEX_INSTALLEDDRIVER | DI_FLAGSEX_ALLOWEXCLUDEDDRVS);        if (!SetupDiSetDeviceInstallParams(DeviceHandle, DeviceInfo, &DeviceInstallParams))
        if (!SetupDiSetDeviceInstallParams(DeviceHandle, DeviceInfo, &DeviceInstallParams))
        {
          GetLastErrorStr();
          return;
        }
        if (!SetupDiBuildDriverInfoList(DeviceHandle, DeviceInfo, SPDIT_COMPATDRIVER))
        {
          GetLastErrorStr();
          return;
        }

        while(SetupDiEnumDriverInfo(DeviceHandle, DeviceInfo, SPDIT_COMPATDRIVER, Index, &DriverInfo))
        {

          String Str;
          TListItem *SetItem;

          DriverInfoDetail.cbSize=sizeof(SP_DRVINFO_DETAIL_DATA);
          SetupDiGetDriverInfoDetail(DeviceHandle, DeviceInfo, &DriverInfo, &DriverInfoDetail, sizeof(SP_DRVINFO_DETAIL_DATA), NULL);

          SetItem=ListView1->Items->Add();

          SetItem->Caption=DriverInfoDetail.DrvDescription;

          Version.QuadPart=DriverInfo.DriverVersion;
          Str=String(HIWORD(Version.HighPart))+"."+
              String(LOWORD(Version.HighPart))+"."+
              String(HIWORD(Version.LowPart))+"."+
              String(LOWORD(Version.LowPart));
          SetItem->SubItems->Append(Str);

          FileTimeToSystemTime(&DriverInfo.DriverDate, &SystemTime);
          GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, &SystemTime, NULL, Buffer, sizeof(Buffer)/sizeof(TCHAR));

          SetItem->SubItems->Append(Buffer);
          SetItem->SubItems->Append(DriverInfo.ProviderName);
          SetItem->SubItems->Append(DriverInfo.MfgName);
          SetItem->SubItems->Append(DriverInfoDetail.InfFileName);

          DriverInstallParams.cbSize=sizeof(DriverInstallParams);
          SetupDiGetDriverInstallParams(DeviceHandle, DeviceInfo, &DriverInfo, &DriverInstallParams);
          if (DriverInstallParams.Flags & DNF_INF_IS_SIGNED)
            Str="Yes";
          else
            Str="No";
          SetItem->SubItems->Append(Str);

          Str=DriverInfoDetail.SectionName;
          SetItem->SubItems->Append(DriverInfoDetail.SectionName);

          Index++;
        }
        ListView1->Update();
}
//---------------------------------------------------------------------------

